# all files / src/widgets/ OptionWidget.js

76.36% Statements 42/55
39.13% Branches 9/23
54.55% Functions 6/11
76.36% Lines 42/55

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226

    1×

    1969×

    1969×

    1969×
    1969×
    1969×
    1969×

    1969×
    1969×
    1969×

    1969×

    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×
    156×

    1×

    1×

    1×
    5728×

    1×
    3128×

    1×

    1×
    624×
    624×
    624×

    624×
    624×

    624×

    624×

    1×

    1×

    1×
    9×
    9×

     /**
     * OptionWidgets are special elements that can be selected and configured with data. The
     * data is often unique for each option, but it does not have to be. OptionWidgets are used
     * with OO.ui.SelectWidget to create a selection of mutually exclusive options. For more information
     * and examples, please see the [OOjs UI documentation on MediaWiki][1].
     *
     * [1]: https://www.mediawiki.org/wiki/OOjs_UI/Widgets/Selects_and_Options
     *
     * @class
     * @extends OO.ui.Widget
     * @mixins OO.ui.mixin.ItemWidget
     * @mixins OO.ui.mixin.LabelElement
     * @mixins OO.ui.mixin.FlaggedElement
     * @mixins OO.ui.mixin.AccessKeyedElement
     *
     * @constructor
     * @param {Object} [config] Configuration options
     */
    OO.ui.OptionWidget = function OoUiOptionWidget( config ) {
    	// Configuration initialization
    	config = config || {};

    	// Parent constructor
    	OO.ui.OptionWidget.parent.call( this, config );

    	// Mixin constructors
    	OO.ui.mixin.ItemWidget.call( this );
    	OO.ui.mixin.LabelElement.call( this, config );
    	OO.ui.mixin.FlaggedElement.call( this, config );
    	OO.ui.mixin.AccessKeyedElement.call( this, config );

    	// Properties
    	this.selected = false;
    	this.highlighted = false;
    	this.pressed = false;

    	// Initialization
    	this.$element
    		.data( 'oo-ui-optionWidget', this )
    		// Allow programmatic focussing (and by accesskey), but not tabbing
    		.attr( 'tabindex', '-1' )
    		.attr( 'role', 'option' )
    		.attr( 'aria-selected', 'false' )
    		.addClass( 'oo-ui-optionWidget' )
    		.append( this.$label );
    };

    /* Setup */

    OO.inheritClass( OO.ui.OptionWidget, OO.ui.Widget );
    OO.mixinClass( OO.ui.OptionWidget, OO.ui.mixin.ItemWidget );
    OO.mixinClass( OO.ui.OptionWidget, OO.ui.mixin.LabelElement );
    OO.mixinClass( OO.ui.OptionWidget, OO.ui.mixin.FlaggedElement );
    OO.mixinClass( OO.ui.OptionWidget, OO.ui.mixin.AccessKeyedElement );

    /* Static Properties */

    /**
     * Whether this option can be selected. See #setSelected.
     *
     * @static
     * @inheritable
     * @property {boolean}
     */
    OO.ui.OptionWidget.static.selectable = true;

    /**
     * Whether this option can be highlighted. See #setHighlighted.
     *
     * @static
     * @inheritable
     * @property {boolean}
     */
    OO.ui.OptionWidget.static.highlightable = true;

    /**
     * Whether this option can be pressed. See #setPressed.
     *
     * @static
     * @inheritable
     * @property {boolean}
     */
    OO.ui.OptionWidget.static.pressable = true;

    /**
     * Whether this option will be scrolled into view when it is selected.
     *
     * @static
     * @inheritable
     * @property {boolean}
     */
    OO.ui.OptionWidget.static.scrollIntoViewOnSelect = false;

    /* Methods */

    /**
     * Check if the option can be selected.
     *
     * @return {boolean} Item is selectable
     */
    OO.ui.OptionWidget.prototype.isSelectable = function () {
    	return this.constructor.static.selectable && !this.isDisabled() && this.isVisible();
    };

    /**
     * Check if the option can be highlighted. A highlight indicates that the option
     * may be selected when a user presses enter or clicks. Disabled items cannot
     * be highlighted.
     *
     * @return {boolean} Item is highlightable
     */
    OO.ui.OptionWidget.prototype.isHighlightable = function () {
    	return this.constructor.static.highlightable && !this.isDisabled() && this.isVisible();
    };

    /**
     * Check if the option can be pressed. The pressed state occurs when a user mouses
     * down on an item, but has not yet let go of the mouse.
     *
     * @return {boolean} Item is pressable
     */
    OO.ui.OptionWidget.prototype.isPressable = function () {
    	return this.constructor.static.pressable && !this.isDisabled() && this.isVisible();
    };

    /**
     * Check if the option is selected.
     *
     * @return {boolean} Item is selected
     */
    OO.ui.OptionWidget.prototype.isSelected = function () {
    	return this.selected;
    };

    /**
     * Check if the option is highlighted. A highlight indicates that the
     * item may be selected when a user presses enter or clicks.
     *
     * @return {boolean} Item is highlighted
     */
    OO.ui.OptionWidget.prototype.isHighlighted = function () {
    	return this.highlighted;
    };

    /**
     * Check if the option is pressed. The pressed state occurs when a user mouses
     * down on an item, but has not yet let go of the mouse. The item may appear
     * selected, but it will not be selected until the user releases the mouse.
     *
     * @return {boolean} Item is pressed
     */
    OO.ui.OptionWidget.prototype.isPressed = function () {
    	return this.pressed;
    };

    /**
     * Set the option’s selected state. In general, all modifications to the selection
     * should be handled by the SelectWidget’s {@link OO.ui.SelectWidget#selectItem selectItem( [item] )}
     * method instead of this method.
     *
     * @param {boolean} [state=false] Select option
     * @chainable
     */
    OO.ui.OptionWidget.prototype.setSelected = function ( state ) {
    	Eif ( this.constructor.static.selectable ) {
    		this.selected = !!state;
    		this.$element
    			.toggleClass( 'oo-ui-optionWidget-selected', state )
    			.attr( 'aria-selected', state.toString() );
    		Eif ( state && this.constructor.static.scrollIntoViewOnSelect ) {
    			this.scrollElementIntoView();
    		}
    		this.updateThemeClasses();
    	}
    	return this;
    };

    /**
     * Set the option’s highlighted state. In general, all programmatic
     * modifications to the highlight should be handled by the
     * SelectWidget’s {@link OO.ui.SelectWidget#highlightItem highlightItem( [item] )}
     * method instead of this method.
     *
     * @param {boolean} [state=false] Highlight option
     * @chainable
     */
    OO.ui.OptionWidget.prototype.setHighlighted = function ( state ) {
    	if ( this.constructor.static.highlightable ) {
    		this.highlighted = !!state;
    		this.$element.toggleClass( 'oo-ui-optionWidget-highlighted', state );
    		this.updateThemeClasses();
    	}
    	return this;
    };

    /**
     * Set the option’s pressed state. In general, all
     * programmatic modifications to the pressed state should be handled by the
     * SelectWidget’s {@link OO.ui.SelectWidget#pressItem pressItem( [item] )}
     * method instead of this method.
     *
     * @param {boolean} [state=false] Press option
     * @chainable
     */
    OO.ui.OptionWidget.prototype.setPressed = function ( state ) {
    	if ( this.constructor.static.pressable ) {
    		this.pressed = !!state;
    		this.$element.toggleClass( 'oo-ui-optionWidget-pressed', state );
    		this.updateThemeClasses();
    	}
    	return this;
    };

    /**
     * Get text to match search strings against.
     *
     * The default implementation returns the label text, but subclasses
     * can override this to provide more complex behavior.
     *
     * @return {string|boolean} String to match search string against
     */
    OO.ui.OptionWidget.prototype.getMatchText = function () {
    	var label = this.getLabel();
    	return typeof label === 'string' ? label : this.$label.text();
    };